/*MySQL version*/

/*
DROP TABLE IF EXISTS UserProds, UserRoles, Users CASCADE;
*/

CREATE TABLE Users(	Name VARBINARY(60) NOT NULL,
										PW CHAR(60) NOT NULL,
										Mail CHAR(60),
										UGroup CHAR(60),
										INDEX( Name ),
										PRIMARY KEY ( Name )
									) TYPE = innodb;

CREATE TABLE UserRoles(	Name VARBINARY(60) NOT NULL,
												Role CHAR(10) NOT NULL,
												INDEX( Name ),
												INDEX( Role ),
												PRIMARY KEY ( Name, Role ),
												FOREIGN KEY ( Name ) REFERENCES Users( Name )
											) TYPE = innodb;

CREATE TABLE Prods(	Name CHAR(60) NOT NULL,
										INDEX( Name ),
										PRIMARY KEY ( Name )
									) TYPE = innodb;

CREATE TABLE UserProds(	Name VARBINARY(60) NOT NULL,
												Prod CHAR(60) NOT NULL,
												Rel CHAR(30) NOT NULL,
												INDEX( Name ),
												INDEX( Prod ),
												PRIMARY KEY ( Name, Prod, Rel ),
												FOREIGN KEY ( Name ) REFERENCES Users( Name ),
												FOREIGN KEY ( Prod ) REFERENCES Prods( Name )
											) TYPE = innodb;

CREATE TABLE UGroups(	Name CHAR(60) NOT NULL,
											INDEX( Name ),
											PRIMARY KEY ( Name )
										) TYPE = innodb;

CREATE TABLE ProdRels(	Prod CHAR(60) NOT NULL,
												Rel CHAR(20) NOT NULL,
												INDEX( Prod ),
												INDEX( Rel ),
												PRIMARY KEY ( Prod, Rel ),
												FOREIGN KEY ( Prod ) REFERENCES Prods( Name )
											) TYPE = innodb;

CREATE TABLE Systems(	Name CHAR(60) NOT NULL,
											INDEX( Name ),
											PRIMARY KEY ( Name )
										) TYPE = innodb;

/* General Data, use Name to separate */
CREATE TABLE DataLst(	Name CHAR(60) NOT NULL,
											Val BINARY(255) NOT NULL,
											INDEX( Name ),
											PRIMARY KEY ( Name, Val )
										) TYPE = innodb;

/* Administrator */
INSERT INTO Users( Name, PW, Mail, UGroup ) VALUES ( 'adm@piqa', SHA('startPW'), '', '' );
INSERT INTO UserRoles( Name, Role ) VALUES ( 'adm@piqa', 'adm' );
INSERT INTO Prods( Name ) VALUES ( 'QANav' );
INSERT INTO UserProds( Name, Prod, Rel ) VALUES ( 'adm@piqa', 'QANav', '' );

/* Default Supervisor */
INSERT INTO Users( Name, PW, Mail, UGroup ) VALUES ( 'super', SHA('startPW'), '', '' );
INSERT INTO UserRoles( Name, Role ) VALUES ( 'super', 'sp' );
INSERT INTO UserProds( Name, Prod, Rel ) VALUES ( 'super', 'QANav', '' );
